/// <reference types="react" />
import { IMoveFile_WSMutationVariables, IUpdateSelectedResourceMutationVariables, IRenameFile_WSMutationVariables, IDeleteFile_WSMutationVariables, ICopyFile_WSMutationVariables, ICreateFile_WSMutationVariables, ICreateFolder_WSMutationVariables, ISetTreeDataMutationVariables, IFileStatWithMetadata } from '@files-stack/core';
import { IFilesMutate, WithReturnVoid, FilesActions } from '@files-stack/client-state';
import { IFilesApiProps } from './file-explorer-tree-component';
export declare namespace IFileExplorerMenuComponent {
    type OwnProps = {};
    interface StateProps {
        filesMutate: IFilesMutate;
        treeData?: any[];
        filesTreeData?: any;
        selectedFile?: IFileStatWithMetadata;
    }
    interface DispatchProps {
        setError?: (error: string, type: string) => any;
        completeMutate?: WithReturnVoid<typeof FilesActions.completeMutateAction>;
        moveFile?: (source: IFileStatWithMetadata, target: IFileStatWithMetadata) => void;
        mutateFile?: WithReturnVoid<typeof FilesActions.mutateFileAction>;
        setCreatingFile?: WithReturnVoid<typeof FilesActions.setCreatingFileAction>;
    }
    interface ApiProps {
        refetch: () => any;
        copyFileMutate: (args: {
            variables: ICopyFile_WSMutationVariables;
        }) => any;
        moveFileMutate: (args: {
            variables: IMoveFile_WSMutationVariables;
        }) => any;
        deleteFileMutate: (args: {
            variables: IDeleteFile_WSMutationVariables;
        }) => any;
        renameFileMutate: (args: {
            variables: IRenameFile_WSMutationVariables;
        }) => any;
        createFileMutate: (args: {
            variables: ICreateFile_WSMutationVariables;
        }) => any;
        createFolderMutate: (args: {
            variables: ICreateFolder_WSMutationVariables;
        }) => any;
        setTreeData?: (args: {
            variables: ISetTreeDataMutationVariables;
        }) => any;
        selectFile?: (args: {
            variables: IUpdateSelectedResourceMutationVariables;
        }) => any;
    }
    type ComponentProps = IFilesApiProps & StateProps & DispatchProps & ApiProps;
    type Props = ComponentProps;
}
export declare const FileExplorerMenu: (props: IFileExplorerMenuComponent.ComponentProps, {}: {}) => JSX.Element;
