import * as React from "react";
import { IFilesMutate } from "@files-stack/client-state";
import { IFileStatWithMetadata } from "@files-stack/core";
import { ILoadFile_WSMutationVariables, IFilesTreeDataFragment as IFilesTreeData, IWatchFileMutationVariables, ISetTreeDataMutationVariables } from "@files-stack/core";
import { IFileExplorerMenuComponent } from "./file-explorer-menu-component";
import { URI } from "@vscode/monaco-editor/esm/vs/base/common/uri";
export interface IFilesDispatchProps {
    refreshDirectory?: () => any;
    setRoot?: (root: string) => any;
    newFile?: (payload: any) => any;
    newFolder?: (payload: any) => any;
    createFile?: (resourcePath: string, mutation: string) => any;
    renameFile?: (resourcePath: string, reName: string) => any;
    cancelEdit?: () => any;
    addSubscribe?: (subscribe: any) => any;
    setExpand?: (expand: boolean) => any;
    changeEditorSubscribes?: (editorSubscribes: string[]) => any;
    reloadTree?: (reload: boolean) => any;
    closeSettings: () => void;
}
export interface IFilesApiProps {
    error?: any;
    loading?: boolean;
    selectFile?: (args: {
        variables: {
            resource: URI;
        };
    }) => any;
    refetch?: () => any;
    subscribeToMore?: Function;
    setTreeData?: (args: {
        variables: ISetTreeDataMutationVariables;
    }) => any;
    loadFileMutate?: (args: {
        variables: ILoadFile_WSMutationVariables;
    }) => any;
    watchFile?: (args: {
        variables: IWatchFileMutationVariables;
    }) => any;
}
export interface IFilesStateProps {
    root?: string;
    width?: number;
    refresh: number;
    filesMutate?: IFilesMutate;
    editorsExpand?: boolean;
    openingFiles?: (IFileStatWithMetadata)[];
    creatingFile?: string;
    filesTreeData?: IFilesTreeData;
    expand?: boolean;
    selectedFile?: IFileStatWithMetadata;
    editorSubscribes?: string[];
    reloadTreeData?: boolean;
    settings: boolean;
    releaseFilePath?: string;
}
export declare type IFilesProps = IFilesApiProps & IFilesDispatchProps & IFilesStateProps & IFileExplorerMenuComponent.DispatchProps;
export declare type IFilesTreeProps = IFilesProps;
export interface IFilesOwnState {
    width?: number;
    height?: number;
    edit?: boolean;
    create?: boolean;
    treeData?: any[];
    lastEditPath?: number[];
    scrollToIndex?: number;
}
export declare const FilesTree: React.FC<IFilesProps>;
